//--------------------------------------------------------------------//
//   e ̑vZ

var COLLATERAL_DIGIT_COUNT=8;	// ]ɌvZ錅 

// vZs
// lineDigit - 1 s̕\
function calc(lineDigit){
  var digit=parseInt(document.getElementById('digit').value);
  if(isNaN(digit)) digit=100;
  digit=Math.min(Math.max(digit,100),50000);
  var obj=document.getElementById('obj').value;
  var str1;
  if(obj==='pi'){
    str1=calcPi(digit,lineDigit);
  }
  else{
    str1=calcE(digit,lineDigit);
  }
  var n=Math.ceil(digit/lineDigit);
  var str=str1[0]+'  1 - '+lineDigit;
  var beginIndex=lineDigit+1;
  for(var i=1;i<n;i++){
    str+='\n';
    var line='  '+str1[i];
    while(line.length<lineDigit+2) line+=' ';
    var endIndex=Math.min(beginIndex+lineDigit-1,digit);
    str+=line+'  '+beginIndex+' - '+endIndex;
    beginIndex=endIndex+1;
  }
  document.getElementById('view').value=str;
}

// ~΂vZ
// n - 
// lineDigit - 1 s̕\
function calcPi(n,lineDigit){
  var coef=Math.log(25)/Math.log(10);
  var n2=parseInt(n/coef)+1;
  var beginIndex=0;
  var endIndex=2+lineDigit;

  var str=[];
  BigNumber.config({DECIMAL_PLACES:n+COLLATERAL_DIGIT_COUNT,
      	      	    ROUNDING_MODE:BigNumber.ROUND_HALF_EVEN});
  var s=new BigNumber(0);
  var w=new BigNumber(80);	// 16~5
  var v=new BigNumber(956);	// 4~239

  for(var i=0;i<n2;i++){
    w=w.div(25);		// 1/5^2
    v=v.div(57121);		// 1/239^2
    var q=w.minus(v).div(2*i+1);
    if((i%2)===0) s=s.plus(q);
    else          s=s.minus(q);
    if(parseInt(coef*i)>=endIndex){
      str.push(String(s).slice(beginIndex,endIndex));
      beginIndex=endIndex;
      endIndex=Math.min(endIndex+lineDigit,n+2);
    }
  }
  while(beginIndex<n+2){
    str.push(String(s).slice(beginIndex,endIndex));
    beginIndex=endIndex;
    endIndex=Math.min(endIndex+lineDigit,n+2);
  }
  return str;
}
// Rΐ̒ilCsAjevZ
// n - 
// lineDigit - 1 s̕\
function calcE(n,lineDigit){
  var beginIndex=0;
  var endIndex=2+lineDigit;

  var str=[];
  BigNumber.config({DECIMAL_PLACES:n+COLLATERAL_DIGIT_COUNT,
      	      	    ROUNDING_MODE:BigNumber.ROUND_HALF_EVEN});
  var s=new BigNumber(1);
  var w=new BigNumber(1);
  var q=new BigNumber(1);

  var iter=0,length=0;
  while(length<=n){
    iter++;
    length=q.toString().length;
    q=q.times(iter);
    w=w.div(iter);
    s=s.plus(w);
    if(length+2>=endIndex){
      str.push(String(s).slice(beginIndex,endIndex));
      beginIndex=endIndex;
      endIndex=Math.min(endIndex+lineDigit,n+2);
    }
  }
  while(beginIndex<n+2){
    str.push(String(s).slice(beginIndex,endIndex));
    beginIndex=endIndex;
    endIndex=Math.min(endIndex+lineDigit,n+2);
  }
  return str;
}
